head	1.3;
access;
symbols;
locks; strict;
comment	@ * @;


1.3
date	96.10.10.20.33.52;	author idr;	state Exp;
branches;
next	1.2;

1.2
date	96.10.08.19.47.12;	author idr;	state Exp;
branches;
next	1.1;

1.1
date	96.10.01.18.38.58;	author idr;	state Exp;
branches;
next	;


desc
@@


1.3
log
@Modified the class so that the ShiftRow() and ShiftCol() functions are
not a part of even the private interface.
@
text
@/* Name : board.c
 *
 * Notes: This file contains all of the functions for creating, destroying,
 *        modifying, and querying Quixo(tm) game boards.
 *
 * $Log: board.cc $
 * Revision 1.2  1996/10/08 19:47:12  idr
 * Added the FixMove() function.
 *
 * Revision 1.1  1996/10/01 18:38:58  idr
 * Initial revision
 */

#include <stdlib.h>
#include "board.h"

void ShiftRow( char board[5][5], int row, int col, int end, int player );
void ShiftCol( char board[5][5], int row, int col, int end, int player );

/*****************************************************************************/
/* Name : IsValidMove()
 *
 * Notes: This function is used to check that a set of source and destination
 *        coordinates define a valid move for the specified playing in the
 *        current game board configuration.
 */

BOOL Board::IsValidMove( move_t move, int player )
{
    size_t  source;


    /* In order for a move to be valid, the selected source piece must be
     * along the perimeter of the playing board.  This means that it must
     * come from a row or 0 or 4, or from a column of 0 or 4.
     */

    if ( (move.srcX == 0) || (move.srcX == 4) 
         || (move.srcY == 0) || (move.srcY == 4) )
    {
        source = board[ move.srcX ][ move.srcY ];

        /* The next test it to make sure that the selected piece is either
         * vacant or is owned by the current player.
         */

        if ( (source == EMPTY) || (source == player) )
        {
            /* The removed piece must be placed in either the same row or
             * column from which it was removed, and it must be placed
             * along the perimeter of the game board.
             */

            if ( ((move.destX == 0) || (move.destX == 4) 
	           || (move.destY == 0) || (move.destY == 4))
                 && ((move.srcX == move.destX) || (move.srcY == move.destY)) )
            {
                /* The final test is to make sure that the source and
                 * destination positions are not the same.
                 */

                return( !( (move.srcX == move.destX) 
                           && (move.srcY == move.destY) ) );
            }
        }
    }

    return( FALSE );
}




/*****************************************************************************/
/* Name :
 *
 * Notes:
 *
 */

BOOL Board::DoMove( move_t move, int player )
{
    /* First, make sure that the caller is requesting that a valid move
     * be made.
     */

    if ( ! IsValidMove( move, player ) )
        return( FALSE );

    if ( move.srcY == move.destY )
    {
        ShiftRow( board, move.srcY, move.srcX, move.destX, player );
    }
    else
    {
        ShiftCol( board, move.srcY, move.srcX, move.destY, player );
    }

    return( TRUE );
}




/*****************************************************************************/
/* Name : ShiftRow()
 *
 * Notes:
 *
 *        If the specified row contains "X O _ _ X", and col = 1 and end = 4,
 *        then the final result will be "X _ _ X O".
 */

void ShiftRow( char board[5][5], int row, int col, int end, int player )
{
    if ( end == 0 )
    {
        for ( /* empty */ ; col > 0 ; col-- )
        {
            board[ col ][ row ] = board[ col - 1 ][ row ] ;
        }
    }
    else
    {
        for ( /* empty */ ; col < 4 ; col++ )
        {
            board[ col ][ row ] = board[ col + 1 ][ row ];
        }
    }

    board[ end ][ row ] = player;
}




/*****************************************************************************/
/* Name : ShiftCol()
 *
 * Notes:
 *
 */

void ShiftCol( char board[5][5], int row, int col, int end, int player )
{
    if ( end == 0 )
    {
        for ( /* empty */ ; row > 0 ; row-- )
        {
            board[ col ][ row ] = board[ col ][ row - 1 ] ;
        }
    }
    else
    {
        for ( /* empty */ ; row < 4 ; row++ )
        {
            board[ col ][ row ] = board[ col ][ row + 1 ];
        }
    }

    board[ col ][ end ] = player;
}




/*****************************************************************************/
/* Name : IsWinner()
 *
 * Notes: This function is used to determin who the winner on a given game
 *        board is.  If there is no winner, it will return EMPTY.
 */

int Board::IsWinner( int player )
{
    int     sum;
    int     x;
    int     y;
    BOOL    player1Won;
    BOOL    player2Won;


    player1Won = FALSE;
    player2Won = FALSE;


    for ( x = 0 ; x < 5 ; x++ )
    {
        sum = 0;

        if ( player != EMPTY )
        {
            for ( y = 0 ; y < 5 ; y++ )
            {
                sum += board[ x ][ y ];
            }
        }

	player1Won |= (sum == -5);
	player2Won |= (sum ==  5);
    }




    for ( y = 0 ; y < 5 ; y++ )
    {
        sum = 0;

        if ( player != EMPTY )
        {
            for ( x = 0 ; x < 5 ; x++ )
            {
                sum += board[ x ][ y ];
            }
        }

	player1Won |= (sum == -5);
	player2Won |= (sum ==  5);
    }



    /* Finally, check the two diagonals.  This is done in much the same way
     * as the other two tests.
     */

    sum = 0;
    for ( x = 1 ; x < 5 ; x++ )
    {
        sum += board[ x ][ x ];
    }

    player1Won |= (sum == -5);
    player2Won |= (sum ==  5);




    sum = 0;
    for ( x = 0 ; x < 5 ; x++ )
    {
        sum += board[ x ][ 4 - x ];
    }

    player1Won |= (sum == -5);
    player2Won |= (sum ==  5);



    if ( player == PLAYER_1 )
    {
        if ( player2Won )
            return ( PLAYER_2 );

        if ( player1Won )
            return ( PLAYER_1 );
    }
    else
    {
        if ( player1Won )
            return ( PLAYER_1 );

        if ( player2Won )
            return ( PLAYER_2 );
    }

    return( EMPTY );
}




/*****************************************************************************/
/* Name : FixMove()
 *
 * Notes: This function is used to convert a move from the "x y side"
 *        representation to the format used in the move_t type.
 */

void FixMove( move_t * m, int x, int y, char side )
{
    m->srcX = x;
    m->srcY = y;

    switch( side )
    {
        case 't':
            m->destX = x;
            m->destY = 0;
            break;

        case 'b':
            m->destX = x;
            m->destY = 4;
            break;

        case 'l':
            m->destX = 0;
            m->destY = y;
            break;

        case 'r':
            m->destX = 4;
            m->destY = y;
            break;
    }
}

@


1.2
log
@Added the FixMove() function.
@
text
@d6 4
a9 1
 * $Log: board.c $
d17 3
d92 1
a92 1
        ShiftRow( move.srcY, move.srcX, move.destX, player );
d96 1
a96 1
        ShiftCol( move.srcY, move.srcX, move.destY, player );
d114 1
a114 1
void Board::ShiftRow( int row, int col, int end, int player )
d144 1
a144 1
void Board::ShiftCol( int row, int col, int end, int player )
@


1.1
log
@Initial revision
@
text
@d6 3
a8 1
 *      $Log:$
d12 1
a12 2
#include <stdtypes.h>
#include "quixo.h"
a13 3
void ShiftRow( struct Board * b, int row, int col, int end, int player );
void ShiftCol( struct Board * b, int row, int col, int end, int player );

d15 1
a15 1
/* Name : AllocBoard()
a16 43
 * Notes:
 *
 */

struct Board * AllocBoard( void )
{
    struct Board * board;


    board = malloc( sizeof( struct Board ) );
    if ( board != NULL )
    {
        /* Once we've allocated the memory that we need, we will need to
         * initialize an empty playing board.
         */

        memset( board, EMPTY, sizeof( board->board ) );
    }

    return( board );
}




/*****************************************************************************/
/* Name : FreeBoard()
 *
 * Notes:
 *
 */

void FreeBoard( struct Board * b )
{
    free( b );
}




/*****************************************************************************/
/* Name : IsMoveValid()
 *
d22 1
a22 2
BOOL IsMoveValid( struct Board * b, int srow, int scol,
                  int drow, int dcol, int player )
d32 2
a33 1
    if ( (srow == 0) || (srow == 4) || (scol == 0) || (scol == 4) )
d35 1
a35 1
        source = (srow * 5) + scol;
d41 1
a41 1
        if ( (b->board[ source ] == EMPTY) || (b->board[ source ] == player) )
d48 3
a50 2
            if ( ((drow == 0) || (drow == 4) || (dcol == 0) || (dcol == 4))
                 && ((srow == drow) || (scol == dcol)) )
d56 2
a57 1
                return( !( (srow == drow) && (scol == dcol) ) );
d75 1
a75 2
BOOL DoMove( struct Board * b, int srow, int scol,
                  int drow, int dcol, int player )
d81 1
a81 1
    if ( ! IsMoveValid( b, srow, scol, drow, dcol, player ) )
d84 1
a84 1
    if ( drow == srow )
d86 1
a86 1
        ShiftRow( b, srow, scol, dcol, player );
d90 1
a90 1
        ShiftCol( b, srow, scol, drow, player );
d108 1
a108 1
void ShiftRow( struct Board * b, int row, int col, int end, int player )
a109 6
    size_t  offset;
    int     piece;


    offset = (row * 5) + col;

d112 1
a112 1
        for ( /* empty */ ; col > 0 ; offset--, col-- )
d114 1
a114 1
            b->board[ offset ] = b->board[ offset - 1 ];
d119 1
a119 1
        for ( /* empty */ ; col < 4 ; offset++, col++ )
d121 1
a121 1
            b->board[ offset ] = b->board[ offset + 1 ];
d125 1
a125 1
    b->board[ (row * 5) + end ] = player;
d138 1
a138 1
void ShiftCol( struct Board * b, int row, int col, int end, int player )
a139 7
    size_t  offset;
    int     piece;


    offset = (row * 5) + col;
    piece = b->board[ offset ];

d142 1
a142 1
        for ( /* empty */ ; row > 0 ; offset -= 5, row-- )
d144 1
a144 1
            b->board[ offset ] = b->board[ offset - 5 ];
d149 1
a149 1
        for ( /* empty */ ; row < 4 ; offset += 5, row++ )
d151 1
a151 1
            b->board[ offset ] = b->board[ offset + 5 ];
d155 1
a155 1
    b->board[ (end * 5) + col ] = piece;
d162 1
a162 1
/* Name : FindWinner()
d168 1
a168 1
int FindWinner( struct Board * b )
d170 5
a174 3
    int     player;
    int     row;
    int     col;
d177 2
a178 3
    /* First, check each row to see if one player entirely occupies any
     * given row.
     */
d180 2
a181 1
    for ( row = 0 ; row < 5 ; row++ )
d183 1
a183 5
        /* See which player occupies the end of the row.  If this player also
         * occupies all of the other columns in this row, then he is the
         * winner.  Note that we don't test the row if the end of it is not
         * occupied.
         */
a184 2
        player = b->board[ (row * 5) + 0 ];

d187 1
a187 1
            for ( col = 1 ; col < 5 ; col++ )
d189 1
a189 2
                if ( b->board[ (row * 5) + col ] != player )
                    break;
d191 1
d193 2
a194 2
            if ( col == 5 ) return( player );
        }
d200 1
a200 5
    /* Now, check each column to see if one player entirely occupies any
     * given column.
     */

    for ( col = 0 ; col < 5 ; col++ )
d202 1
a202 5
        /* See which player occupies the end of the column.  If this player
         * also occupies all of the other rows in this columns, then he is the
         * winner.  Note that we don't test the column if the end of it is not
         * occupied.
         */
a203 2
        player = b->board[ (0 * 5) + col ];

d206 1
a206 1
            for ( row = 1 ; row < 5 ; row++ )
d208 1
a208 2
                if ( b->board[ (row * 5) + col ] != player )
                    break;
d210 1
d212 2
a213 2
            if ( row == 5 ) return( player );
        }
d222 2
a223 2
    player = b->board[ (0 * 5) + 0 ];
    for ( row = 1 ; row < 5 ; row++ )
d225 1
a225 2
        if ( b->board[ (row * 5) + row ] != player )
            break;
d228 2
a229 1
    if ( row == 5 ) return( player );
d233 3
a235 2
    player = b->board[ (0 * 5) + 5 ];
    for ( row = 1, col = 4 ; row < 5 ; row++, col-- )
d237 1
a237 2
        if ( b->board[ (row * 5) + col ] != player )
            break;
d240 2
a241 1
    if ( row == 5 ) return( player );
d245 4
d250 7
a256 1
    /* If we couldn't find a winner, then we return EMPTY. */
d258 4
d264 40
@
