#ifndef STDTYPES_H
#define STDTYPES_H

/* If the compiler does not support the "void" type (i.e., pre-ANSI C), then
 * the preprocessor macro "VOID" should be defined to be an empty string.
 */

#ifndef VOID
#define VOID            void
#endif

/* WARNING: An APTR is a 32-Bit Absolute Memory Pointer.  C pointer math will
 *          not operate on APTR --  use "ULONG *" or "UBYTE *" instead.
 */

#ifndef APTR_TYPEDEF
#define APTR_TYPEDEF
typedef void          * APTR;       /* 32-bit untyped pointer */
#endif

typedef long            LONG;       /* signed 32-bit quantity */
typedef unsigned long   ULONG;      /* unsigned 32-bit quantity */
typedef unsigned long   LONGBITS;   /* 32 bits manipulated individually */

typedef short           WORD;       /* signed 16-bit quantity */
typedef unsigned short  UWORD;      /* unsigned 16-bit quantity */
typedef unsigned short  WORDBITS;   /* 16 bits manipulated individually */
#if __STDC__
typedef signed char     BYTE;       /* signed 8-bit quantity */
#else
typedef char            BYTE;       /* signed 8-bit quantity */
#endif
typedef unsigned char   UBYTE;      /* unsigned 8-bit quantity */
typedef unsigned char   BYTEBITS;   /* 8 bits manipulated individually */

#ifdef __cplusplus
typedef char          * STRPTR;     /* string pointer (NUL terminated) */
#else
typedef unsigned char * STRPTR;     /* string pointer (NUL terminated) */
#endif


/* Types with specific semantics */
typedef float           FLOAT;
typedef double          DOUBLE;
typedef unsigned char   TEXT;
typedef long            ERROR;

/*@-booltype BOOL@*/
typedef short           BOOL;

#ifndef TRUE
#define TRUE            1
#endif
#ifndef FALSE
#define FALSE           0
#endif
#ifndef NULL
#define NULL            0L
#endif

#define NUL             '\0'

#define BYTEMASK        0x0FF

#endif
