

/* Name : minmax.cc
 *
 * $Log:	minmax.cc,v $
Revision 1.5  96/11/15  15:53:16  viji
before

Revision 1.4  96/11/12  13:01:27  viji
fine heuristic 

Revision 1.3  96/11/06  15:17:18  viji
version without compilation errors

Revision 1.2  96/11/01  15:11:04  viji
before tree , changes

 */

#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <unistd.h>
#include <memory.h>
#include <sys/time.h>
#include "board.h"  
#include "quixo.h"
#include "quixi.h"
#include "minmax.h"


int MYTURN , HISTURN;
void printboard( char [5][5]);

void UnFixMove (move_t z, int x ,int y, char side);

Best_Move minmax_AB (char [5][5],move_t move_list,int,int,int,int);


int	next_player,VALUE, PATH;

//move_t move_list[45];

void	boardcopy(char b[5][5],char temp[5][5]) {

	memcpy ( temp, b, 25);

}


int opponent(int player) {

if(player == PLAYER_1)
    return PLAYER_2;
else
    return PLAYER_1;
}

void	printboard (char b[5][5])
{

//	Show the temp board.  

	int i,j;	
	int	 O =  PLAYER_2;	//  Represents Player_2.  
	int	 X =  PLAYER_1;	//  Represents PLAYER_1.
	for (i=0; i < 5; i++)  {
		for (j=0;j < 5; j++)
		{
		    if (b[i][j] == X)
			fprintf(stderr, "X ");
		    else if (b[i][j] == O)
			fprintf(stderr, "O ");
		    else
			fprintf(stderr, "_ ");
	        }
		fprintf(stderr, "\n");
	}	


}


int	 heuristic(char b[5][5] ,int  p ) {
	int	i,j;
	int	R1SumX = 0, R2SumX = 0, R3SumX = 0, R4SumX = 0, R5SumX = 0;
	int	C1SumX = 0, C2SumX = 0, C3SumX = 0, C4SumX = 0, C5SumX = 0;
	int	R1SumO = 0, R2SumO = 0, R3SumO = 0, R4SumO = 0, R5SumO = 0;
	int	C1SumO = 0, C2SumO = 0, C3SumO = 0, C4SumO = 0, C5SumO = 0;
	int	SumXDiagonal1 = 0, SumXDiagonal2 = 0, tempO = 0;
	int	SumODiagonal1 = 0, SumODiagonal2 = 0, tempX = 0; 
	int	 O =  PLAYER_2;	//  Represents Player_2.  
	int	 X =  PLAYER_1;	//  Represents PLAYER_1.


//	Show the temp board.  
	printboard(b);  
 
//	Sum the rows and columns with X's and O's.  
	fprintf(stderr,"p: %d\n",p);  
	for (j=0; j < 5; j++)  
	   for (i=0; i < 5; i++)  {
	  	if (j==0 && b[j][i] == X) C1SumX++;
	  	if (j==0 && b[j][i] == O) C1SumO--;
	  	if (j==1 && b[j][i] == X)   C2SumX++; 
	  	if (j==1 && b[j][i] == O)  C2SumO--;
	  	if (j==2 && b[j][i] == X) C3SumX++;
	  	if (j==2 && b[j][i] == O) C3SumO--;
	  	if (j==3 && b[j][i] == X)  C4SumX++; 
	  	if (j==3 && b[j][i] == O) C4SumO--;
	  	if (j==4 && b[j][i] == X)  C5SumX++; 
	  	if (j==4 && b[j][i] == O) C5SumO--;
	   }  //  end for  	

/*	fprintf(stderr," C1SumX: %d\t", C1SumX);  
	fprintf(stderr," C1SumO: %d\t", C1SumO);  
	fprintf(stderr," C2SumX: %d\t", C2SumX);  
	fprintf(stderr," C2SumO: %d\t", C2SumO);  
	fprintf(stderr," C3SumX: %d\t", C3SumX);  
	fprintf(stderr," C3SumO: %d\t", C3SumO);  
	fprintf(stderr," C4SumX: %d\t", C4SumX);  
	fprintf(stderr," C4SumO: %d\t", C4SumO);  
	fprintf(stderr," C5SumX: %d\t", C5SumX);  
	fprintf(stderr," C5SumO: %d\n", C5SumO);      
	fprintf(stderr," C5SumO: %d\n", C5SumO); */      

	for (i=0; i < 5; i++)
	   for (j=0;j < 5; j++)  {
	  	if (i==0 && b[j][i] == X)  R1SumX++;   
	  	if (i==0 && b[j][i] == O) R1SumO--; 
	  	if (i==1 && b[j][i] == X)  R2SumX++; 
	  	if (i==1 && b[j][i] == O) R2SumO--; 
	  	if (i==2 && b[j][i] == X)  R3SumX++; 
	  	if (i==2 && b[j][i] == O) R3SumO--;   
	  	if (i==3 && b[j][i] == X)  R4SumX++;   
	  	if (i==3 && b[j][i] == O) R4SumO--; 
	  	if (i==4 && b[j][i] == X)  R5SumX++;  
	  	if (i==4 && b[j][i] == O) R5SumO--;  
	   }   // end for  	


/*	fprintf(stderr," R1SumX: %d\t", R1SumX);  
	fprintf(stderr," R1SumO: %d\t", R1SumO);  
	fprintf(stderr," R2SumX: %d\t", R2SumX);  
	fprintf(stderr," R2SumO: %d\t", R2SumO);  
	fprintf(stderr," R3SumX: %d\t", R3SumX);  
	fprintf(stderr," R3SumO: %d\t", R3SumO);  
	fprintf(stderr," R4SumX: %d\t", R4SumX);  
	fprintf(stderr," R4SumO: %d\t", R4SumO);  
	fprintf(stderr," R5SumX: %d\t", R5SumX);  
	fprintf(stderr," R5SumO: %d\n", R5SumO);  
*/

//	Sum the two diagonals for X's and O's

	for (i=0; i < 5; i++)  {
		if (b[i][i] == X)  SumXDiagonal1++;
		if (b[i][i] == O)  SumODiagonal1--;
	}
	
	for (i=0; i < 5; i++)  {
		if (b[i][4-i] == X)  SumXDiagonal2++;
		if (b[i][4-i] == O)  SumXDiagonal2--;  
	}

/*	fprintf(stderr,"SumXDiagonal1: %d\t",SumXDiagonal1);
	fprintf(stderr,"SumODiagonal1: %d\n",SumODiagonal1);
	fprintf(stderr,"SumXDiagonal2: %d\t",SumXDiagonal2);
	fprintf(stderr,"SumODiagonal2: %d\n",SumODiagonal2);
*/

//	Determine Max
	if (R1SumX >= R2SumX) tempX = R1SumX; else tempX = R2SumX;
  	if (tempX >= R3SumX) ; else tempX = R3SumX;
	if (tempX >= R4SumX) ; else tempX = R4SumX;
	if (tempX >= R5SumX) ; else tempX = R5SumX;
	if (tempX >= C1SumX) ; else tempX = C1SumX; 
	if (tempX >= C2SumX) ; else tempX = C2SumX; 
	if (tempX >= C3SumX) ; else tempX = C3SumX;
	if (tempX >= C4SumX) ; else tempX = C4SumX;
	if (tempX >= C5SumX) ; else tempX = C5SumX;
	if (tempX >= SumXDiagonal1); else tempX=SumXDiagonal1;
	if (tempX >= SumXDiagonal2); else tempX=SumXDiagonal2;

// 	Determine Min
	if (R1SumO <= R2SumO) tempO = R1SumO; else tempO = R2SumO;
  	if (tempO <= R3SumO) ; else tempO = R3SumO;
	if (tempO <= R4SumO) ; else tempO = R4SumO;
	if (tempO <= R5SumO) ; else tempO = R5SumO;
	if (tempO <= C1SumO) ; else tempO = C1SumO; 
	if (tempO <= C2SumO) ; else tempO = C2SumO; 
	if (tempO <= C3SumO) ; else tempO = C3SumO;
	if (tempO <= C4SumO) ; else tempO = C4SumO;
	if (tempO <= C5SumO) ; else tempO = C5SumO;
	if (tempO <= SumODiagonal1); else tempO=SumODiagonal1;
	if (tempO <= SumODiagonal2); else tempO=SumODiagonal2;


	fprintf(stderr,"tempX: %d, tempO: %d\n",tempX,tempO);  
	fprintf(stderr, "heristic:  %d\n", (tempX+tempO));  


	return (tempX + tempO);  
	
}   //  end heuristics  


void goodmove(Board &b , int player) {

	Best_Move bm;
	move_t	move_list;  
	int x  , y ;
	char side ;
	char temp[5][5];
	char *ptr;
	ptr = &temp[0][0];

	MYTURN = player;
	HISTURN = opponent(player);

	// get possible moves into the array, modify possible moves

	boardcopy(b.board,temp);

	bm = minmax_AB(temp, move_list,0, player, -100 , 100 );
	//fprintf(stderr, "goodmove: bm.destX: %d\n",bm.destX);
	UnFixMove(bm.move, x , y, side);

}

int Possible_MoveGen(char temp[5][5], move_t move_list[],int p) {

	int count = 0;
	char side[] = {'t','b','l','r'};
	//char	z;

	move_t m;

	   for( int j = 0 ; j < 5; j++) // column
       		for(int k = 0 ; k < 5; k++) // row
       		   for(int l = 0; l < 4 ; l++) {
//	    		fprintf(stderr,"j: %d, k: %d, %c\n",j,k,side[l]);
            		FixMove ( & m , j , k , side[l]);
//	    		UnFixMove ( m, j,  k, z);   
            		if (LIsValidMove( temp, m , p)) {
              		    move_list[count] = m;  // Save possible moves.   
             		    count++;
             		} //end if
          	   }	//end for   
   	if (count == 0)
		return count;	
   	else 
		return count - 1;   //  Returns number of possible moves.

}// end	Possible_MoveGen


int best_score = 0;

Best_Move  minmax_AB (char b_state[5][5],move_t move_lis,
			int cur_depth,  int player,
              		int alpha_max,int beta_min) 

{
  int i = 0, count;	// best_score; 
  Best_Move result ;
  move_t M,best_move;
  move_t move_list[45]; 
  int	O = PLAYER_2;    
//  char temp_state[5][5];

  if (cur_depth == DESIRED_DEPTH){  // return heuristic(b_state)NULL;
	result.thresh = heuristic (b_state, player);
       
  	result.move.srcX = NULL;
  	result.move.srcY = NULL;
 	 result.move.destX = NULL;
 	 result.move.destY = NULL;
	return result;    // Return best move
	} 

 count = Possible_MoveGen(b_state,move_list,player);// Count & gather possible moves
	fprintf(stderr, "count: %d, depth: %d\n", count, cur_depth);
//	fprintf(stderr, "move_list[%d].srcX: %d\n", 0, move_list[0].srcX);  
//	fprintf(stderr, "move_list[%d].srcY: %d\n", 0, move_list[0].srcY);  
  best_move.srcX = NULL; 
  best_move.srcY = NULL; 
  best_move.destX = NULL; 
  best_move.destY = NULL; 

  if ((LIsWinner (b_state, player)) == TRUE)
		return result;

  i = count ;

while(i > 0 ) { // Does for loop job  
    fprintf(stderr,"enter while,  i=%d  player is %d\n",i, player);
  	ApplyMove (b_state, move_list[i],player);
//	memcpy (temp_state, b_state, 25);  
	result = minmax_AB(b_state , move_list[i],cur_depth+1 ,
	    opponent(player),  alpha_max, beta_min);  

	M = move_list[i];		// Store move information
        fprintf(stderr, "m.destX: %d,m.destY  %d\n", move_list[i].destX, move_list[i].destY);

	i--;
	fprintf (stderr, "result.thresh: %d, alpha_max %d, beta_min %d\n",
		result.thresh,alpha_max,beta_min);

	 // If I am O, prune check for O.  

	if (player == MYTURN && player == O)  result.thresh *= -1;   


	if(player == MYTURN) { 
		fprintf(stderr,"MYTURN\n");  
    		if(result.thresh > alpha_max) {
      			alpha_max = result.thresh;
      			best_move = M;
      			best_score = result.thresh;
    		fprintf(stderr, "best_move.destX: %d\n",best_move.destX);	
    		fprintf(stderr, "best_move.destY: %d\n",best_move.destY);	
		}
    		if(alpha_max >= beta_min) {
      			result.thresh = beta_min;
        		result.move = best_move; 
		fprintf(stderr,"result.move.destX: %d\n",result.move.destX);
		fprintf(stderr,"result.move.destY: %d\n",result.move.destY);
   			return  result;
     	}}
	else 
	if(player == HISTURN) { 
		fprintf(stderr, "HISTURN\n");   
   		if(result.thresh < beta_min) {
      			beta_min = result.thresh;
      			best_move = M;
      			best_score = result.thresh;
    		}
    		if(alpha_max <= beta_min) {
        		result.thresh = alpha_max;
        		result.move = best_move;    
		fprintf(stderr,"result.move.destX: %d\n",result.move.destX);
		fprintf(stderr,"result.move.destY: %d\n",result.move.destY);
    			return  result;
    	}}
/*	 result.thresh = best_score;
	result.move = best_move;    
	return  result;  
 */      
       
	fprintf(stderr, "at end while loop bracket\n"); 
  } // end while loop
	result.thresh = best_score;
	result.move = best_move;    
	return  result;


} // end minmax



void UnFixMove( move_t  z, int x , int y , char side)
{
     x = z.srcX ;
     y = z.srcY ;

    if( z.destX == x && z.destY == 4)
       side = 'b';
    else
    if( z.destX == 4 && z.destY == y)
       side = 'r';
    else
    if( z.destX == 0 && z.destY == y)
       side = 'l';
    else
    if(z.destX == x && z.destY == 0)
       side = 't';
   else

   fprintf(stderr,"x y side is \n");


   fprintf(stderr,"x y side is %d %d %c \n",x , y , side );
}	//  end UnFixMove.

