#include <stdio.h>
#include <string.h>
#include <stdlib.h>


ShowBoard(char board[5][5])
{
 int i,j;
 printf("  0 1 2 3 4\n");
 for (i=0; i<5; i++)
 {
  printf("%d ",i);
  for (j=0; j<5; j++) printf("%c ",board[j][i]);
  printf("\n");
 }
}

int validMove(char board[5][5],int x, int y, char side, int turn) {
 
 int found=0;
 if ((x==0) || (x==4) || (y==0) || (y==4)) found=1;
 if (found==0) return 0;

 if ((x==0) && (side=='l')) return 0;
 if ((x==4) && (side=='r')) return 0;
 if ((y==4) && (side=='b')) return 0;
 if ((y==0) && (side=='t')) return 0;

 if (board[x][y]=='.') return 1;
 else if (turn==1)
        {
            if (board[x][y]=='X') return 1;
            else return 0;
        }
        else
        {
            if (board[x][y]=='O') return 1;
            else return 0;
        }
}

SwitchTurn(int *turn) {
        if (*turn==0) { *turn=1; 
	/*	printf("X's turn to move.\n");  */
		}
        else { *turn=0; 
	/* printf("O's turn to move.\n"); */
		}
    }

pushTop(int loc, char board[5][5], int turn) {
        int blank;
	int j;

        for (blank=0; board[loc][blank]!=' '; blank++);
        for (j=blank; j>0; j--)
          {
            board[loc][j]=board[loc][j-1];
          }
        if (turn==0) board[loc][0]='O';
        else board[loc][0]='X';
}

pushBot(int loc, char board[5][5], int turn) {
        int blank,j;

        for (blank=0; board[loc][blank]!=' '; blank++);
        for (j=blank; j<4; j++)
          {
            board[loc][j]=board[loc][j+1];
            board[loc][j]=board[loc][j+1];
          }
        if (turn==0) board[loc][4]='O';
        else board[loc][4]='X';
    }

pushLeft(int loc, char board[5][5], int turn) {
        int blank,j;

        for (blank=0; board[blank][loc]!=' '; blank++);
        for (j=blank; j>0; j--)
        {
            board[j][loc]=board[j-1][loc];
        }
        if (turn==0) board[0][loc]='O';
        else board[0][loc]='X';
    }

pushRight(int loc, char board[5][5], int turn) {
        int blank,j;

        for (blank=0; board[blank][loc]!=' '; blank++);
        for (j=blank; j<4; j++)
        {
            board[j][loc]=board[j+1][loc];
        }
        if (turn==0) board[4][loc]='O';
        else board[4][loc]='X';
    }

MakeMove(int x, int y, char side, char board[5][5], int turn)
{
 if (validMove(board,x,y,side,turn))
  {
   board[x][y]=' ';
   if (side=='l') pushLeft(y,board,turn);
   else if (side=='r') pushRight(y,board,turn);
   else if (side=='t') pushTop(x,board,turn);
   else if (side=='b') pushBot(x,board,turn);
  }
}

int CheckForWin(char board[5][5], int whoseturn)
 {
  int numinrow=0;
  char piece;
  int j=0; int i=0;
  int xwin=0, owin=0;

  for (i=0; i<5; i++)
   if (board[i][0]!='.')
        {
          numinrow=0;
          piece=board[i][0];
          for (j=0; j<5; j++)
            if (board[i][j]==piece) numinrow++;
          if (numinrow==5)
            {
             if (piece=='X') xwin=1; else owin=1;
            }
        }

  for (j=0; j<5; j++)
    if (board[0][j]!='.')
        {
          piece=board[0][j];
          numinrow=0;
          for (i=0; i<5; i++)
          {
            if (board[i][j]==piece) numinrow++;
          }
          if (numinrow==5)
            {
             if (piece=='X') xwin=1; else owin=1;
            }
        }

   if (board[0][0]!='.')
        {
          piece=board[0][0];
          numinrow=0; j=0; i=0;
          for (; i<5; j++,i++)
            if (board[i][j]==piece) numinrow++;
          if (numinrow==5)
            {
             if (piece=='X') xwin=1; else owin=1;
            }
        }
       if (board[0][4]!='.')
        {
          piece=board[0][4];
          numinrow=0; j=4; i=0;
          for (; i<5; j--,i++)
            if (board[i][j]==piece) numinrow++;
          if (numinrow==5)
            {
             if (piece=='X') xwin=1; else owin=1;
            }
        }

	if ((xwin!=1) && (owin!=1)) return -1;
	if ((xwin==1) && (owin==0)) return 1;
	if ((xwin==0) && (owin==1)) return 0;
	if ((xwin==1) && (owin==1))
   	{
	  if (whoseturn==1) return 0;
	  return 1;
	}
	printf("Error!\n"); exit(0);
    }


int AddOrCheckBoard(char board[5][5],int which)
{
 static int num=0;
 static char oldboards[100][5][5];
 int i;

 if (which==0)			/* Add new board to saved boards */
 {
  if (num==100)  /* Shift board down */
  {
   for (i=0; i<99; i++)
     memcpy((char *) oldboards[i], (char *) oldboards[i+1],
 		5*5*sizeof(char));
   memcpy((char *) oldboards[99], (char *) board[0],
		5*5*sizeof(char));
  } 
  else
  {
    memcpy((char *) oldboards[num], (char *) board[0],
		5*5*sizeof(char));
    num++;
  }
  return 0;
 }
 else				/* see if board exists */
 {
  for (i=0; i<num; i++)
   if (memcmp((char *) oldboards[i],(char *) board[0], 5*5)==0)
     return 1;
  return 0;
 }
}

main(int argc, char *argv[])
{
 int i,j,w;
 char board[5][5],side;
 int turn, whoami;

 if (argc!=2) 
  { printf("Usage: squisho 1  or  squisho 2\nUse with Quixo Manager by idr.\n");
    exit(0); 
  }

 if (argv[1][0]=='1') whoami=1;
 else whoami=0;

 ResetBoard(board);
 turn = 0;		
 
 while ((w=CheckForWin(board,turn))==-1)
 {
/*
  ShowBoard(board);
*/
  SwitchTurn(&turn);

  if (turn!=whoami) scanf("%d %d %c",&i,&j,&side);
/*
  if (turn==1) GetComputerMove(board,&i,&j,&side,turn,6); 
*/
  else 
  {
   GetComputerMove(board,&i,&j,&side,turn,6); 
   printf("%d %d %c\n",i,j,side);
   fflush(stdout);
  }
  MakeMove(i,j,side,board,turn);
  AddOrCheckBoard(board,0);
 }
/*
 ShowBoard(board);
 if (w==0) printf("O is the winner!!!");
 else if (w==1) printf("X is the winner!!!");
*/
}


ResetBoard(char board[5][5])
{
 int i,j;
 for (i=0; i<5; i++)
  for (j=0; j<5; j++)
   board[i][j]='.';
}

